/* The Cantus project.
 * (c)2002, 2003, 2004 by Samuel Abels (spam debain org)
 * This project's homepage is: http://www.debain.org/cantus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifndef HAVE_GNUHASHMAP_H
#define HAVE_GNUHASHMAP_H

#include <ext/hash_set>

#ifdef __GNUC__
  #if __GNUC__ < 3
    #include <hash_map.h>
    namespace __gnu_cxx { using ::hash_map; }; // inherit globals
  #endif // __GNUC__ < 3
  
  #if __GNUC__ == 3
    #include <ext/hash_map>
    #if __GNUC_MINOR__ == 0
      #namespace __gnu_cxx = std;
    #endif // __GNUC_MINOR__ == 0
    
    #if __GNUC_MINOR__ > 1
      namespace __gnu_cxx {  // Import string operator.
        template<>
        struct hash<std::string> {
        public:
          size_t operator()(std::string str) const {
            __gnu_cxx::hash<char const*> H;
            return H(str.c_str() );
          }
        };
        
        struct eqptr {
          bool operator()(void* s1, void* s2) const {
            return (s1 == s2);
          }
        };
      };
    #endif // __GNUC_MINOR__ > 1
  #endif // __GNUC__ == 3
#else
  #namespace __gnu_cxx = std;
#endif // __GNUC__

#endif
